/* Program tok.cc         */
/* By Harald Stauss       */
/* Last change 11.03.2000 */

#define MAX_FIELD 50

#include <iostream.h>
#include <fstream.h>
#include <string.h>
#include <stdio.h>

main(int argc, char *argv[]) {
  float    version;
  int      l_pos, tok_pos, n_tok, i;
  ifstream indat;
  ofstream outdat;
  char     *linie, *f[MAX_FIELD], *tok;
  short    is_quote, n_header_items;

  /* Hello World */
  cout << "bst2hst Ver.1.0 by H. Stauss, 2001 \n";
  if (argc != 3)
    {
      cout << "Number of parameters wrong! \n";
      cout << "Convert Bernhards TeX format in Haralds DAT format \n";
      cout << "bst2hst f_in f_out \n";
      cout << "f_in  : name of input file. \n";
      cout << "f_out : name of output file. \n";
      goto ende;
    }

  /* initialization */
  linie =new char[1000];
  /* Eingabedatei oeffnen */
  indat.open(argv[1]);
  if (!indat) {
    cout << "Can't open file " << argv[1] << "\n";
    goto ende;
  }
  /* Ausgabedatei oeffnen */
  outdat.open(argv[2]);
  if (!outdat) {
    cout << "Can't open file " << argv[2] << "\n";
    goto ende;
  }
  cout << "Input file   : " << argv[1] << "\n";
  cout << "Output file  : " << argv[2] << "\n";

  /*  M A I N L O O P  */
  while (!indat.eof()) {
    indat.getline(linie,1000);
    if ((linie[0]=='\\') && (linie[1]=='m')) {
      n_tok=0;
      tok=strtok(linie,":");
      f[n_tok]=tok;
      n_tok++;
      tok=strtok(NULL,"/");
      f[n_tok]=tok;
      n_tok++;
      tok=strtok(NULL,":");
      f[n_tok]=tok;
      n_tok++;
      tok=strtok(NULL,",");
      f[n_tok]=tok;
      n_tok++;
      tok=strtok(NULL,",");
      f[n_tok]=tok;
      n_tok++;
      tok=strtok(NULL,"*");
      f[n_tok]=tok;
      outdat << '"' << f[1] << '"' << ","
	     << '"' << f[2] << '"' << ","
	     << '"' << f[4] << '"' << ","
	     << "false,false,"
	     << '"' << f[5] << '"' << ","
	     << "0.00,0.00,";
      if(!strcmp(f[3],"\br"))  outdat << "40,23 \n";
      else if(!strcmp(f[3],"\\sh"))  outdat << "23,40 \n";
      else if(!strcmp(f[3],"\\qu"))  outdat << "30,25 \n"; 
      else if(!strcmp(f[3],"\\ho"))  outdat << "25,30 \n"; 
      else if(!strcmp(f[3],"\\sm"))  outdat << "19,23 \n"; 
      else if(!strcmp(f[3],"\\sb"))  outdat << "23,19 \n"; 
      else if(!strcmp(f[3],"\\sg"))  outdat << "20,25 \n"; 
      else if(!strcmp(f[3],"\\gr"))  outdat << "52,30 \n"; 
      else if(!strcmp(f[3],"\\gh"))  outdat << "30,52 \n"; 
      else if(!strcmp(f[3],"\\q2"))  outdat << "32,32 \n"; 
      else if(!strcmp(f[3],"\\kq"))  outdat << "20,20 \n"; 
      else if(!strcmp(f[3],"\\sq"))  outdat << "65,37 \n"; 
      else if(!strcmp(f[3],"\\zm"))  outdat << "19,11 \n"; 
      else if(!strcmp(f[3],"\\bq"))  outdat << "21,21 \n"; 
      else if(!strcmp(f[3],"\\yq"))  outdat << "21,21 \n"; 
      else if(!strcmp(f[3],"\\ys"))  outdat << "19,21 \n"; 
      else if(!strcmp(f[3],"\\yh"))  outdat << "22,25 \n"; 
      else if(!strcmp(f[3],"\\yl"))  outdat << "37,33 \n"; 
      else if(!strcmp(f[3],"\\yk"))  outdat << "31,37 \n"; 
      else if(!strcmp(f[3],"\\yg"))  outdat << "35,21 \n"; 
      else if(!strcmp(f[3],"\\yw"))  outdat << "26,21 \n"; 
      else if(!strcmp(f[3],"\\el"))  outdat << "19,21 \n"; 
      else if(!strcmp(f[3],"\\tq"))  outdat << "21,21 \n"; 
      else if(!strcmp(f[3],"\\wq"))  outdat << "23,23 \n"; 
      else if(!strcmp(f[3],"\\ws"))  outdat << "19,22 \n"; 
      else if(!strcmp(f[3],"\\wb"))  outdat << "34,24 \n"; 
      else if(!strcmp(f[3],"\\wk"))  outdat << "26,22 \n"; 
      else if(!strcmp(f[3],"\\wh"))  outdat << "20,24 \n"; 
      else if(!strcmp(f[3],"\\wf"))  outdat << "40,22 \n"; 
      else if(!strcmp(f[3],"\\bd0")) outdat << "18,18 \n"; 
      else if(!strcmp(f[3],"\\bd2")) outdat << "20,20 \n"; 
      else if(!strcmp(f[3],"\\bd5")) outdat << "23,23 \n"; 
      else if(!strcmp(f[3],"\\bsq")) outdat << "22,19 \n"; 
      else if(!strcmp(f[3],"\\bsh")) outdat << "19,22 \n"; 
      else if(!strcmp(f[3],"\\bs2")) outdat << "24,24 \n"; 
      else if(!strcmp(f[3],"\\brh")) outdat << "22,26 \n"; 
      else if(!strcmp(f[3],"\\hgh")) outdat << "21,23 \n"; 
      else if(!strcmp(f[3],"\\hvh")) outdat << "21,23 \n"; 
      else if(!strcmp(f[3],"\\hgh")) outdat << "19,22 \n"; 
      else if(!strcmp(f[3],"\\lus")) outdat << "18,23 \n"; 
      else if(!strcmp(f[3],"\\luh")) outdat << "19,22 \n"; 
      else if(!strcmp(f[3],"\\msq")) outdat << "22,22 \n"; 
      else if(!strcmp(f[3],"\\mzh")) outdat << "19,22 \n"; 
      else if(!strcmp(f[3],"\\bdn")) outdat << "18,18 \n";
      else if(!strcmp(f[3],"\\bdz")) outdat << "20,20 \n";
      else if(!strcmp(f[3],"\\bdf")) outdat << "23,23 \n";
      else if(!strcmp(f[3],"\\heh")) outdat << "19,22 \n";
      else if(!strcmp(f[3],"\\nph")) outdat << "19,22 \n";
      else if(!strcmp(f[3],"\\npq")) outdat << "22,19 \n";
      else if(!strcmp(f[3],"\\olh")) outdat << "19,22 \n";
      else if(!strcmp(f[3],"\\oll")) outdat << "19,23 \n";
      else if(!strcmp(f[3],"\\oln")) outdat << "20,22 \n";
      else if(!strcmp(f[3],"\\prh")) outdat << "19,22 \n";
      else if(!strcmp(f[3],"\\prq")) outdat << "23,19 \n";
      else if(!strcmp(f[3],"\\sa2")) outdat << "18,18 \n";
      else if(!strcmp(f[3],"\\sah")) outdat << "18,22 \n";
      else if(!strcmp(f[3],"\\sal")) outdat << "19,24 \n";
      else if(!strcmp(f[3],"\\sab")) outdat << "22,24 \n";
      else if(!strcmp(f[3],"\\shk")) outdat << "19,22 \n";
      else if(!strcmp(f[3],"\\shh")) outdat << "20,23 \n";
      else if(!strcmp(f[3],"\\sh2")) outdat << "19,19 \n";
      else outdat << "23,26 \n";
    } 
  }  /* endwhile */
  
  delete[]linie;
  indat.close(); outdat.close();

 ende: 
  return(0);

} /* Ende von main */
